﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;

namespace SampleApp 
{
     
    /// <summary>
    /// Represents view model for a Marker and provides access to DataItem
    /// </summary>
    public class MarkerControl : ObservableModel //Control
    {
        public MarkerControl()
        {
            _data = new ScatterDataItem();
            //default to Collapsed value
            _highlightControl = new Control();
            _highlightControl.Visibility = Visibility.Collapsed;
            _annotaionControl = new Control();
            _annotaionControl.Visibility = Visibility.Collapsed;
            //Visibility = Visibility.Collapsed;
           // HighlightVisibility = Visibility.Collapsed;
            //AnnotaionVisibility = Visibility.Collapsed;
        }
       // public ScatterDataItem Data { get; set; }
        private ScatterDataItem _data = new ScatterDataItem();
        public ScatterDataItem Data
        {
            get { return _data; }
            set
            {
                //if (_data != null)
                //    _data.PropertyChanged -= _data_PropertyChanged;

                _data = value;
                //_data.PropertyChanged += _data_PropertyChanged;
                OnPropertyChanged("Data");
            }
        }

        void _data_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            OnPropertyChanged("Data");
        }

        private Control _highlightControl = new Control();
        public Control HighlightControl
        {
            get { return _highlightControl; }
            set { _highlightControl = value; OnPropertyChanged("HighlightControl"); }
        }
        private Control _annotaionControl = new Control();
        public Control AnnotaionControl
        {
            get { return _annotaionControl; }
            set { _annotaionControl = value; OnPropertyChanged("AnnotaionControl"); }
        }

        private int _zOrder = 1;
        public int ZOrder
        {
            get { return _zOrder; }
            set { _zOrder = value; OnPropertyChanged("ZOrder"); }
        }
        //public Visibility HighlightVisibility { get; set; }
        //public Visibility AnnotaionVisibility { get; set; }

        public void HideHighlight()
        {
            HighlightControl.Visibility = Visibility.Collapsed;
        }
        public void ShowHighlight()
        {
            HighlightControl.Visibility = Visibility.Visible;
        }

        public void HideAnnotaion()
        {
            AnnotaionControl.Visibility = Visibility.Collapsed;
        }
        public void ShowAnnotaion()
        {
            AnnotaionControl.Visibility = Visibility.Visible;
        }
    }

   
 
}