﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace SampleApp
{
    public class ThresholdVisibilityConverterBase : IValueConverter
    {
        public ThresholdVisibilityConverterBase()
        {
            ThresholdVisibility = Visibility.Visible;
        }
        public Visibility ThresholdVisibility { get; set; }
        public Visibility GetOposite(Visibility visibility)
        {
            return visibility == Visibility.Visible ? Visibility.Collapsed : Visibility.Visible;
        }
        public virtual object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        public virtual object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class ThresholdValueToVisibilityConverter : ThresholdVisibilityConverterBase
    {
        public ThresholdValueToVisibilityConverter()
        {
            this.ThresholdValue = 0.0;
        }
        /// <summary>
        /// Threshold value used to compare with converter's value 
        /// </summary>
        public double ThresholdValue { get; set; }
        
        public override object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null || !(value is double))
                 return GetOposite(ThresholdVisibility);
             // if (!(value is double))
          
            var actual = (double)value;
            if (actual > ThresholdValue)
            {
                return ThresholdVisibility;
            }

            return GetOposite(ThresholdVisibility);
        }

        //public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        //{
        //    throw new NotImplementedException();
        //}
    }
    public class ThresholdStringToVisibilityConverter : ThresholdVisibilityConverterBase
    {
        public ThresholdStringToVisibilityConverter()
        {
            this.ThresholdString = string.Empty;
        }
        /// <summary>
        /// Threshold value used to compare with converter's value 
        /// </summary>
        public string ThresholdString { get; set; }

        public override object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null || !(value is string))
                return GetOposite(ThresholdVisibility);
            
            var actual = (string)value;
            if (actual != ThresholdString)
            {
                return ThresholdVisibility;
            }

            return GetOposite(ThresholdVisibility);
        }

        //public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        //{
        //    throw new NotImplementedException();
        //}
    }
    
}