﻿using System;
using System.Collections.Generic;
using System.Windows;

namespace IGShowcase.CompositeCharts
{
    public class SampleContourData : ScatterDataList
    {

        public void AddRandomPoints(int xBase, int yBase, double value)
        {
            var x = 0.0; var y = 0.0;
            for (int ii = 0; ii < 10; ii++)
            {
                if (rand.NextDouble() % 0.5 == 0)
                    x = xBase + (rand.Next(1, 10));
                else
                    x = xBase - (rand.Next(1, 10));
                if (rand.NextDouble() % 0.5 == 0)
                    y = yBase + (rand.Next(1, 10));
                else
                    y = yBase - (rand.Next(1, 10));
                var key = x + "_" + y;
                if (!ContourPoints.ContainsKey(key)) ContourPoints.Add(key, new ScatterDataItem { X = x, Y = y, Value = value });
            }
        }
        protected Random rand = new Random();
        protected Dictionary<string, ScatterDataItem> ContourPoints;
        public SampleContourData()
        {
            ContourPoints = new Dictionary<string, ScatterDataItem>();
            var vMin = 0;
            var vMax = 10;
            var xMin = -100;
            var xMax = 100;
            var yMin = -100;
            var yMax = 100;

            for (int i = 0; i < 10; i++)
            {
                var value = rand.Next(vMin, vMax);
                var xBase = rand.Next(xMin, xMax);
                var yBase = rand.Next(yMin, yMax);

                this.AddRandomPoints(xBase, yBase, value);

            }
            var offset = 50;
            this.AddRandomPoints(xMin - offset, yMin - offset, rand.Next(vMin, vMax));
            this.AddRandomPoints(xMax + offset, yMin - offset, rand.Next(vMin, vMax));
            this.AddRandomPoints(xMax + offset, yMax + offset, rand.Next(vMin, vMax));
            this.AddRandomPoints(xMin - offset, yMax + offset, rand.Next(vMin, vMax));

            foreach (var item in ContourPoints)
            {
                this.Add(item.Value);
            }

        }


    }
    public class RandomShape
    {
        public double Width { get; set; }
        public double Height { get; set; }
        public double X { get; set; }
        public double Y { get; set; }

        public List<Point> Points()
        {
            var points = new List<Point>();
            var rand = new Random();
            var halfWidth = Width / 2;
            var halfHeight = Height / 2;

            var x = 0.0; var y = 0.0;

            for (int i = 0; i < 10; i++)
            {
                if (rand.NextDouble() % 0.5 == 0)
                    x = X + (halfWidth * rand.NextDouble());
                else
                    x = X - (halfWidth * rand.NextDouble());
                if (rand.NextDouble() % 0.5 == 0)
                    y = Y + (halfHeight * rand.NextDouble());
                else
                    y = Y - (halfHeight * rand.NextDouble());
                points.Add(new Point(x, y));
            }

            //points.Add(new Point(X, Y));
            //points.Add(new Point(X + Width, Y));
            //points.Add(new Point(X + Width, Y + Height));
            //points.Add(new Point(X, Y + Height));
            return points;
        }
    }

}