﻿using System;
using System.Collections.Generic;
using System.Windows;
using Infragistics.Controls.Charts;

namespace SampleApp
{
    public class TriangulationData
    {
        public TriangulationData()
        {
            //TODO add your own data 
            DataSource = new SampleHeatData();

            // create Triangulation source
            this.TriangulationSource = TriangulationSource.Create(DataSource.Count,
            (i) => new Point(DataSource[i].X, DataSource[i].Y),
            (i) => Convert.ToSingle(DataSource[i].Value));

            // create Triangulation mesh
            TriangulationMesh = new List<List<Point>>();
            TriangulationMeshPoints = new List<Point>();

            var records = TriangulationSource.Points;
            foreach (var triangle in TriangulationSource.Triangles)
            {
                var trianglePoints = new List<Point>();
                //var index = triangle.V1;
                //var record = records[index];
                //trianglePoints.Add(record.Point);

                trianglePoints.Add(records[triangle.V1].Point);
                trianglePoints.Add(records[triangle.V2].Point);
                trianglePoints.Add(records[triangle.V3].Point);

                TriangulationMeshPoints.Add(new Point(double.NaN, double.NaN));
                TriangulationMeshPoints.Add(new Point(double.NaN, double.NaN));
                TriangulationMeshPoints.AddRange(trianglePoints);
                TriangulationMeshPoints.Add(new Point(double.NaN, double.NaN));
                TriangulationMeshPoints.Add(new Point(double.NaN, double.NaN));

                TriangulationMesh.Add(trianglePoints);
            }
        }

        public ScatterDataList DataSource { get; set; }

        public List<Point> TriangulationMeshPoints { get; set; }

        public List<List<Point>> TriangulationMesh { get; set; }
        public TriangulationSource TriangulationSource { get; set; }

    }


    public class SampleHeatData : ScatterDataList
    {
        public SampleHeatData()
        {
            var value = 0;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 0 });
            this.Add(new ScatterDataItem() { Value = value, X = 50, Y = 0 });
            this.Add(new ScatterDataItem() { Value = value, X = 100, Y = 0 });
            this.Add(new ScatterDataItem() { Value = value, X = 150, Y = 0 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 0 });
            value = 6;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 30 });
            this.Add(new ScatterDataItem() { Value = value, X = 25, Y = 30 });
            this.Add(new ScatterDataItem() { Value = value, X = 75, Y = 30 });
            this.Add(new ScatterDataItem() { Value = value, X = 125, Y = 25 });
            this.Add(new ScatterDataItem() { Value = value, X = 175, Y = 25 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 25 });
            value = 6;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 50 });
            this.Add(new ScatterDataItem() { Value = value, X = 50, Y = 50 });
            this.Add(new ScatterDataItem() { Value = value, X = 100, Y = 50 });
            this.Add(new ScatterDataItem() { Value = value, X = 150, Y = 60 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 60 });
            value = 3;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 80 });
            this.Add(new ScatterDataItem() { Value = value, X = 25, Y = 80 });
            this.Add(new ScatterDataItem() { Value = value, X = 75, Y = 80 });
            this.Add(new ScatterDataItem() { Value = value, X = 125, Y = 70 });
            this.Add(new ScatterDataItem() { Value = value, X = 175, Y = 70 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 70 });
            value = 3;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 90 });
            this.Add(new ScatterDataItem() { Value = value, X = 50, Y = 90 });
            this.Add(new ScatterDataItem() { Value = value, X = 100, Y = 90 });
            this.Add(new ScatterDataItem() { Value = value, X = 150, Y = 100 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 100 });

            value = 5;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 120 });
            this.Add(new ScatterDataItem() { Value = value, X = 25, Y = 120 });
            this.Add(new ScatterDataItem() { Value = value, X = 75, Y = 120 });
            this.Add(new ScatterDataItem() { Value = value, X = 125, Y = 125 });
            this.Add(new ScatterDataItem() { Value = value, X = 175, Y = 125 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 125 });

            value = 5;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 150 });
            this.Add(new ScatterDataItem() { Value = value, X = 50, Y = 150 });
            this.Add(new ScatterDataItem() { Value = value, X = 100, Y = 160 });
            this.Add(new ScatterDataItem() { Value = value, X = 150, Y = 160 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 160 });

            value = 9;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 170 });
            this.Add(new ScatterDataItem() { Value = value, X = 25, Y = 170 });
            this.Add(new ScatterDataItem() { Value = value, X = 75, Y = 170 });
            this.Add(new ScatterDataItem() { Value = value, X = 125, Y = 170 });
            this.Add(new ScatterDataItem() { Value = value, X = 175, Y = 180 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 180 });

            value = 9;
            this.Add(new ScatterDataItem() { Value = value, X = 0, Y = 200 });
            this.Add(new ScatterDataItem() { Value = value, X = 40, Y = 200 });
            this.Add(new ScatterDataItem() { Value = value, X = 70, Y = 200 });
            this.Add(new ScatterDataItem() { Value = value, X = 120, Y = 200 });
            this.Add(new ScatterDataItem() { Value = value, X = 200, Y = 200 });


        }
    }

   
}