﻿using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Controls.Charts;

namespace SampleApp
{
    public partial class HeatChart : UserControl
    {
        public HeatChart()
        {
            InitializeComponent();

            //var data = new TriangulationData();

        }

        private void Selector_OnSelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (this.DataChart == null) return;
            if (this.DataChart.Series.Count == 0) return;

            var series = this.DataChart.Series.OfType<ScatterAreaSeries>().First();
            var scale = series.ColorScale as CustomPaletteColorScale;
            var mode = e.AddedItems[0];
            if (scale != null)
                scale.InterpolationMode = (ColorScaleInterpolationMode)mode;
        }

        
        private void OnHeatMeshPointsVisCheckboxClick(object sender, RoutedEventArgs e)
        {
            var checkBox = sender as CheckBox;
            var isChecked = checkBox.IsChecked.HasValue && checkBox.IsChecked.Value;
            var series = this.DataChart.Series.OfType<ScatterSeries>().First();
            series.Visibility = isChecked ? Visibility.Visible : Visibility.Collapsed;
        }
        private void OnHeatMeshLinesVisCheckboxClick(object sender, RoutedEventArgs e)
        {
            var checkBox = sender as CheckBox;
            var isChecked = checkBox.IsChecked.HasValue && checkBox.IsChecked.Value;
            var series = this.DataChart.Series.OfType<ScatterLineSeries>().First();
            series.Visibility = isChecked ? Visibility.Visible : Visibility.Collapsed;
        }
        private void OnHeatMapContoursVisCheckboxClick(object sender, RoutedEventArgs e)
        {
            var checkBox = sender as CheckBox;
            var isChecked = checkBox.IsChecked.HasValue && checkBox.IsChecked.Value;
            var series = this.DataChart.Series.OfType<ContourLineSeries>().First();
            series.Visibility = isChecked ? Visibility.Visible : Visibility.Collapsed;
        }
        private void OnHeatMapAreaVisCheckboxClick(object sender, RoutedEventArgs e)
        {
            var checkBox = sender as CheckBox;
            var isChecked = checkBox.IsChecked.HasValue && checkBox.IsChecked.Value;

            var series = this.DataChart.Series.OfType<ScatterAreaSeries>().First();
            series.Visibility = isChecked ? Visibility.Visible : Visibility.Collapsed;
        }

        public void ToggleVisibilty(CheckBox checkBox, Series series)
        {
            var isChecked = checkBox.IsChecked.HasValue && checkBox.IsChecked.Value;
            series.Visibility = isChecked ? Visibility.Visible : Visibility.Collapsed;
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
           // this.DataChart.DataContext = new SampleContourData();
        }
    }
}
