﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics;
using Infragistics.Controls.Charts;

namespace SampleApp
{
    public partial class ScatterChartLabels : UserControl
    {
        public ScatterChartLabels()
        {
            InitializeComponent();

            this.Loaded += ScatterChartLabels_Loaded;
        }

        protected NumericXAxis XAxis;
        protected AxisLabelsVisibilityConverter XAxisConverter;
       
        void ScatterChartLabels_Loaded(object sender, RoutedEventArgs e)
        {
            XAxis = DataChart1.Axes.OfType<NumericXAxis>().First();
            XAxisConverter = this.Resources["AxisLabelsVisibility"] as AxisLabelsVisibilityConverter;
        }
       
        private void DataChart1_OnActualWindowRectChanged(object sender, RectChangedEventArgs e)
        {
            // update axis labels on ActualWindowRectChanged
            UpdateAxisLabelVisibility();
        }

        private void DataChart1_OnSizeChanged(object sender, SizeChangedEventArgs e)
        {
            // update axis labels on ChartSizeChanged
            UpdateAxisLabelVisibility();
        }

        private void UpdateAxisLabelVisibility()
        {
            var axisLabelsVisibility = this.Resources["AxisLabelsVisibility"] as AxisLabelsVisibilityConverter;
            if (axisLabelsVisibility != null)
            {
                axisLabelsVisibility.ResetLabelsCounter();
            }
            XAxis.RenderAxis();
        }
    }
}
